List AI custom rulesets

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

GET https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.ap2.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.datadoghq.eu/api/v2/static-analysis/ai/rulesetshttps://api.ddog-gov.com/api/v2/static-analysis/ai/rulesetshttps://api.us2.ddog-gov.com/api/v2/static-analysis/ai/rulesetshttps://api.uk1.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.us3.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets

Información general

Get all AI custom rulesets for the authenticated organization.

Argumentos

Cadenas de consulta

Nombre

Tipo

Descripción

page[offset]

integer

The offset for pagination.

page[limit]

integer

The maximum number of rulesets to return.

Respuesta

Successful response

Response containing a list of AI custom rulesets.

Expand All

Campo

Tipo

Descripción

data [required]

[object]

The list of AI custom rulesets.

attributes [required]

object

Response attributes of an AI custom ruleset.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the ruleset.

description [required]

string

Base64-encoded full description of the ruleset.

name [required]

string

The ruleset name.

rules [required]

[object]

The rules contained in the ruleset.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the rule.

last_revision [required]

object

The most recent revision of the rule.

category [required]

enum

Rule category Allowed enum values: SECURITY,BEST_PRACTICES,CODE_STYLE,ERROR_PRONE,PERFORMANCE

checksum [required]

string

Checksum of the revision content.

content [required]

string

Base64-encoded AI model content for this revision.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the revision.

cwe [required]

string

The associated CWE identifier.

description [required]

string

Base64-encoded full description.

directories [required]

[string]

Directory patterns this rule applies to.

execution_mode [required]

enum

The execution mode for an AI rule revision. Allowed enum values: auto,manual,always

globs [required]

[string]

File glob patterns this rule applies to.

is_default [required]

boolean

Whether this is a default Datadog rule.

is_published [required]

boolean

Whether this revision is published.

is_testing [required]

boolean

Whether this revision is for testing only.

severity [required]

enum

Rule severity Allowed enum values: ERROR,WARNING,NOTICE

short_description [required]

string

Base64-encoded short description.

version_id [required]

int64

The version identifier for this revision.

name [required]

string

The rule name.

short_description [required]

string

Base64-encoded short description of the ruleset.

id [required]

string

The ruleset identifier.

type [required]

enum

AI custom ruleset resource type. Allowed enum values: ai_ruleset

{
  "data": [
    {
      "attributes": {
        "created_at": "2024-01-01T00:00:00+00:00",
        "created_by": "example-handle",
        "description": "Ruleset description",
        "name": "my-ai-ruleset",
        "rules": [
          {
            "created_at": "2024-01-01T00:00:00+00:00",
            "created_by": "example-handle",
            "last_revision": {
              "category": "SECURITY",
              "checksum": "abc123def456",
              "content": "Content",
              "created_at": "2024-01-01T00:00:00+00:00",
              "created_by": "example-handle",
              "cwe": "79",
              "description": "Ruleset description",
              "directories": [
                []
              ],
              "execution_mode": "auto",
              "globs": [
                "**/*.py"
              ],
              "is_default": false,
              "is_published": false,
              "is_testing": false,
              "severity": "ERROR",
              "short_description": "Ruleset short description",
              "version_id": 1
            },
            "name": "my-ai-rule"
          }
        ],
        "short_description": "Ruleset short description"
      },
      "id": "my-ai-ruleset",
      "type": "ai_ruleset"
    }
  ]
}

Unauthorized

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Internal Server Error

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Ejemplo de código

                  # Curl command
curl -X GET "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets" \ -H "Accept: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}"
"""
List AI custom rulesets returns "Successful response" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.static_analysis_api import StaticAnalysisApi

configuration = Configuration()
configuration.unstable_operations["list_ai_custom_rulesets"] = True
with ApiClient(configuration) as api_client:
    api_instance = StaticAnalysisApi(api_client)
    response = api_instance.list_ai_custom_rulesets()

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
# List AI custom rulesets returns "Successful response" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.list_ai_custom_rulesets".to_sym] = true
end
api_instance = DatadogAPIClient::V2::StaticAnalysisAPI.new
p api_instance.list_ai_custom_rulesets()

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
// List AI custom rulesets returns "Successful response" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.ListAiCustomRulesets", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStaticAnalysisApi(apiClient)
	resp, r, err := api.ListAiCustomRulesets(ctx, *datadogV2.NewListAiCustomRulesetsOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StaticAnalysisApi.ListAiCustomRulesets`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StaticAnalysisApi.ListAiCustomRulesets`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
// List AI custom rulesets returns "Successful response" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StaticAnalysisApi;
import com.datadog.api.client.v2.model.AiCustomRulesetsResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.listAiCustomRulesets", true);
    StaticAnalysisApi apiInstance = new StaticAnalysisApi(defaultClient);

    try {
      AiCustomRulesetsResponse result = apiInstance.listAiCustomRulesets();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StaticAnalysisApi#listAiCustomRulesets");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
// List AI custom rulesets returns "Successful response" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_static_analysis::ListAiCustomRulesetsOptionalParams;
use datadog_api_client::datadogV2::api_static_analysis::StaticAnalysisAPI;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.ListAiCustomRulesets", true);
    let api = StaticAnalysisAPI::with_config(configuration);
    let resp = api
        .list_ai_custom_rulesets(ListAiCustomRulesetsOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * List AI custom rulesets returns "Successful response" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.listAiCustomRulesets"] = true;
const apiInstance = new v2.StaticAnalysisApi(configuration);

apiInstance
  .listAiCustomRulesets()
  .then((data: v2.AiCustomRulesetsResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"